package pac;

import org.hibernate.Session;
import org.hibernate.SessionFactory; //importante que sea org.hibernate, se pueden importar otras librerias.
import org.hibernate.cfg.Configuration;

import java.util.HashSet;

public class Main {
    public static void main(String[] args) { //psvm
        SessionFactory sessionFactory = new Configuration().configure().buildSessionFactory(); //Creamos un session factory. Con el configure, indicamos que fichero abrimos, como no le pasamos parámetro, será el fichero por defecto.
        Session session = sessionFactory.openSession(); //Abrimos la comunicación con la base de datos

        //Creamos los módulos
        Modulo progb = new Modulo("Programacion B", "M03B");
        Modulo accd = new Modulo("Acceso a Datos", "M06");
        Modulo desappmol = new Modulo("Desarrollo de aplicaciones moviles", "M08");
        Modulo serpro = new Modulo("Servicios y procesos, M09", "M09");
        guardarmodulo(session, progb);
        guardarmodulo(session, accd);
        guardarmodulo(session, desappmol);
        guardarmodulo(session, serpro);
        Alumno alumno1 = new Alumno ("Juan", "Espaniola", 26, "Hombre", new HashSet <Modulo>(){{
            add(progb);
            add(accd);
            add(desappmol);
            add(serpro);
        }});
        Alumno alumno2 = new Alumno ("Pedro", "Andorrana", 21, "Hombre", new HashSet <Modulo>(){{
            add(progb);
            add(accd);
            add(serpro);
        }});
        Alumno alumno3 = new Alumno ("Marta", "Espaniola", 19, "Mujer", new HashSet <Modulo>(){{
            add(desappmol);
            add(serpro);
        }});
        Alumno alumno4 = new Alumno ("Carla", "Francesa", 35, "Mujer", new HashSet <Modulo>(){{
            add(accd);
            add(desappmol);
            add(serpro);
        }});
        guardaralumno(session, alumno1);
        guardaralumno(session, alumno2);
        guardaralumno(session, alumno3);
        guardaralumno(session, alumno4);

        Profesor profesor = new Profesor ("Alvaro", "Hombre");
        guardarprofesor(session, profesor);
        session.close();
    }

    private static void guardarmodulo (Session session, Modulo modulo) { //Vamos a guardar todos los módulos en la base de datos.
        session.beginTransaction(); //Para que los datos vuelvan al inicio si no se guardase bien debido a un error.
        session.save(modulo);
        System.out.println("Insert into modulo, nombre: " + modulo.getNombre()+ ", codigo: " + modulo.getCodigo());
        session.getTransaction().commit();
    }
    private static void guardaralumno (Session session, Alumno alumno) { //Vamos a guardar todos los módulos en la base de datos.
        session.beginTransaction(); //Para que los datos vuelvan al inicio si no se guardase bien debido a un error.
        session.save(alumno);
        System.out.println("Insert into alumno, nombre: "+ alumno.getNombre() +", nacionalidad: "+ alumno.getNacionalidad() + ", edad: "+ alumno.getEdad()+", sexo: "+alumno.getSexo()+", modulos: "+ alumno.getModulos().size());
        session.getTransaction().commit();
    }
    private static void guardarprofesor (Session session, Profesor profesor) {
        session.beginTransaction();
        session.save(profesor);
        System.out.println("Insert into profesor, nombre: "+ profesor.getNombre()+", sexo:" + profesor.getSexo());
        session.getTransaction().commit();
    }
}
